# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

Public Member Functions | Private Member Functions | Private Attributes | Friends | List of all members
dirac::CodeBlock Class Reference

Class for encapsulating metadata concerning a block of coefficients in a subband.

`#include <wavelet_utils.h>`

## Public Member Functions
| CodeBlock ()
| Constructor. More...
| CodeBlock (const int xstart, const int ystart, const int xend, const int yend)
| Constructor. More...
int | Xstart () const
| Returns the horizontal start of the block. More...
int | Ystart () const
| Returns the vertical start of the block. More...
int | Xend () const
| Returns one past the last coefficient coord, horizontally. More...
int | Yend () const
| Returns one past the last coefficient coord, vertically. More...
int | Xl () const
| Returns the width of the code block. More...
int | Yl () const
| Returns the height of the code block. More...
int | QuantIndex () const
| Returns the quantisation index associated to the code block. More...
bool | Skipped () const
| Returns true if the code-block is skipped, false if not. More...
void | SetQuantIndex (const int quantindex)
| Sets the quantisation index. More...
void | SetSkip (bool skip)
| Sets whether the code block is skipped or not. More...

## Private Member Functions
void | Init (const int xstart, const int ystart, const int xend, const int yend)
| Initialise the code block. More...

## Private Attributes
int | m_xstart
int | m_ystart
int | m_xend
int | m_yend
int | m_xl
int | m_yl
int | m_quantindex
bool | m_skipped

## Friends
class | Subband

## Constructor & Destructor Documentation

## ◆ CodeBlock() [1/2]

dirac::CodeBlock::CodeBlock | ( |  | ) |

## ◆ CodeBlock() [2/2]

dirac::CodeBlock::CodeBlock | ( | const int | xstart,
|  | const int | ystart,
|  | const int | xend,
|  | const int | yend
| ) |  |

## Member Function Documentation

## ◆ Init()

void dirac::CodeBlock::Init | ( | const int | xstart,
|  | const int | ystart,
|  | const int | xend,
|  | const int | yend
| ) |  |
| private

## ◆ QuantIndex()

int dirac::CodeBlock::QuantIndex | ( |  | ) | const
| inline

References m_quantindex.

Referenced by dirac::GenericBandCodec< EntropyCodec >::CodeCoeffBlock().

## ◆ SetQuantIndex()

void dirac::CodeBlock::SetQuantIndex | ( | const int | quantindex | ) |
| inline

References m_quantindex.

## ◆ SetSkip()

void dirac::CodeBlock::SetSkip | ( | bool | skip | ) |
| inline

References m_skipped.

Referenced by dirac::GenericBandCodec< EntropyCodec >::DoWorkDecode().

## ◆ Skipped()

bool dirac::CodeBlock::Skipped | ( |  | ) | const
| inline

References m_skipped.

## ◆ Xend()

int dirac::CodeBlock::Xend | ( |  | ) | const
| inline

References m_xend.

Referenced by dirac::GenericBandCodec< EntropyCodec >::ClearBlock(), dirac::GenericIntraDCBandCodec< EntropyCodec >::ClearBlock(), dirac::GenericBandCodec< EntropyCodec >::CodeCoeffBlock(), dirac::GenericBandCodec< EntropyCodec >::DecodeCoeffBlock(), dirac::GenericIntraDCBandCodec< EntropyCodec >::DecodeCoeffBlock(), and dirac::GenericBandCodec< EntropyCodec >::SetToVal().

## ◆ Xl()

int dirac::CodeBlock::Xl | ( |  | ) | const
| inline

References m_xl.

## ◆ Xstart()

int dirac::CodeBlock::Xstart | ( |  | ) | const
| inline

References m_xstart.

Referenced by dirac::GenericBandCodec< EntropyCodec >::ClearBlock(), dirac::GenericIntraDCBandCodec< EntropyCodec >::ClearBlock(), dirac::GenericBandCodec< EntropyCodec >::CodeCoeffBlock(), dirac::GenericBandCodec< EntropyCodec >::DecodeCoeffBlock(), dirac::GenericIntraDCBandCodec< EntropyCodec >::DecodeCoeffBlock(), and dirac::GenericBandCodec< EntropyCodec >::SetToVal().

## ◆ Yend()

int dirac::CodeBlock::Yend | ( |  | ) | const
| inline

References m_yend.

Referenced by dirac::GenericBandCodec< EntropyCodec >::ClearBlock(), dirac::GenericIntraDCBandCodec< EntropyCodec >::ClearBlock(), dirac::GenericBandCodec< EntropyCodec >::CodeCoeffBlock(), dirac::GenericBandCodec< EntropyCodec >::DecodeCoeffBlock(), dirac::GenericIntraDCBandCodec< EntropyCodec >::DecodeCoeffBlock(), and dirac::GenericBandCodec< EntropyCodec >::SetToVal().

## ◆ Yl()

int dirac::CodeBlock::Yl | ( |  | ) | const
| inline

References m_yl.

## ◆ Ystart()

int dirac::CodeBlock::Ystart | ( |  | ) | const
| inline

References m_ystart.

Referenced by dirac::GenericBandCodec< EntropyCodec >::ClearBlock(), dirac::GenericIntraDCBandCodec< EntropyCodec >::ClearBlock(), dirac::GenericBandCodec< EntropyCodec >::CodeCoeffBlock(), dirac::GenericBandCodec< EntropyCodec >::DecodeCoeffBlock(), dirac::GenericIntraDCBandCodec< EntropyCodec >::DecodeCoeffBlock(), and dirac::GenericBandCodec< EntropyCodec >::SetToVal().

## Friends And Related Function Documentation

## ◆ Subband

friend class Subband
| friend

## Member Data Documentation

## ◆ m_quantindex

int dirac::CodeBlock::m_quantindex
| private

Referenced by QuantIndex(), and SetQuantIndex().

## ◆ m_skipped

bool dirac::CodeBlock::m_skipped
| private

Referenced by SetSkip(), and Skipped().

## ◆ m_xend

int dirac::CodeBlock::m_xend
| private

Referenced by Xend().

## ◆ m_xl

int dirac::CodeBlock::m_xl
| private

Referenced by Xl().

## ◆ m_xstart

int dirac::CodeBlock::m_xstart
| private

Referenced by Xstart().

## ◆ m_yend

int dirac::CodeBlock::m_yend
| private

Referenced by Yend().

## ◆ m_yl

int dirac::CodeBlock::m_yl
| private

Referenced by Yl().

## ◆ m_ystart

int dirac::CodeBlock::m_ystart
| private

Referenced by Ystart().

The documentation for this class was generated from the following file:

- wavelet_utils.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.